/*******************************************************************************
 *
 * File Name: ANNTraining.h
 * Author: Richard Baxter
 * Project: Advanced Neural Network (ANN)
 * Project Version: 1j2h 16-Feb-07
 * Comments:
 *
 *******************************************************************************/

#ifndef NEURON_TRAINING_HEADER
#define NEURON_TRAINING_HEADER

#include "ANNneuronClass.h"
#include "ANNexperienceClass.h"


#define	MAX_NUM_FOLDS_ANNTH 10
#define IRRELEVANT 0.0
#define	ACCEPTABLE_ERROR_RATE 0.01F
	//99% accuracy is defined as the acceptable error rate. no more epochs will be calculated once this is reached.

#define	MAX_NUMBER_OF_EPOCHS 500
#define ERROR_VARIATION_ALLOWED 0.002F








void feedNeuralNetworkWithASetOfExperiences(NeuronContainer * firstInputNeuron, NeuronContainer * firstOutputNeuron, int numberOfInputNeurons, int numberOfOutputNeurons, Experience * firstExperienceInList);


void trainNeuralNetwork(NeuronContainer * firstInputNeuron, NeuronContainer * firstOutputNeuron, int numberOfInputNeurons, int numberOfOutputNeurons, int maxFolds, Experience * firstExperienceInDataSet, long numberOfExperiences);

	void storeNeuralNetworkBiasAndWeights(NeuronContainer * firstInputNeuron);
	void restoreNeuralNetworkWithStoredBiasAndWeights(NeuronContainer * firstInputNeuron);
	void resetNeuralNetworkWithRandomBiasAndWeights(NeuronContainer * firstInputNeuron);
	void resetInputsAndClassTargets(NeuronContainer * firstInputNeuron, NeuronContainer * firstOutputNeuron, long numberOfInputNeurons, long numberOfOutputNeurons, Experience * currentExperienceInDataSet);
	float calculateStandardDeviation(float* array, int length, float average);


#endif
