/*******************************************************************************
 *
 * File Name: LDreferenceManipulation.h
 * Author: Richard Baxter
 * Project: Generic Construct Functions
 * Project Version: 3e2a 16-Feb-07
 *
 *******************************************************************************/


#ifndef HEADER_REFERENCEMANIPULATION
#define HEADER_REFERENCEMANIPULATION

#include "LDreferenceClass.h"

#define DAT_FILE_GENERIC_MAX_SIZE (100000000)		//100MB - the maximum size of any ldraw .DAT/.LDR file

/*currently shared routines*/



bool search1DRefListFindRef(Reference * referenceToFind, Reference * initialReferenceInList);		//not currently used
bool search1DRefListNameAndColourFindRef(Reference * referenceToFind, Reference * initialReferenceInList);
bool search1DRefListReplaceRef(Reference * referenceToFind, Reference * referenceToReplaceWith, Reference * initialReferenceInList);	//not currently used
bool search1DRefListNameAndColourReplaceRef(Reference * referenceToFind, Reference * referenceToReplaceWith, Reference * initialReferenceInList);
bool search1DRefListAddReference(Reference * initialReferenceInList, Reference * referenceToAdd);
bool compareReferenceNameAndColour(Reference * reference, string referenceName, int referenceColour);
void copyReferences(Reference * referenceNew, Reference * referenceToCopy, int type);
#ifdef USE_LRRC
void copyReferencesAndSubmodelDetails(Reference * referenceNew, Reference * referenceToCopy, int type);		//not currently used
#endif
bool compareReferences(Reference * reference1, Reference * reference2, int type);


void addNewLineCharacterToString(char * string);
void addSpaceCharacterToString(char * string);
void convertPositionCoordinatesToString(vec * spriteSceneCoords, char * string);
bool writeReferencesToFile(char * fileName, Reference * firstReference);
bool convertReferencesToByteArray(Reference * firstReference, char * fileByteArray, int * fileByteArraySize);
bool convertReferenceToString(Reference * currentReference, char * submodelReferenceString);
void writeFile(char * sceneFileName, char * sceneFileByteArray, int sceneFileByteArraySize);
bool readFile(char * sceneFileName, char * sceneFileByteArray, int * sceneFileNumberOfLines, int * sceneFileByteArraySize);
void copyFiles(char * newFileName, char * fileToCopyName);

/*sprite routines*/
void convertRotationMatrixToString(mat * rotationMatrix, char * string);
bool findTextInByteArray(char * byteArray, int byteArraySize, char * searchString, int searchStringLength, int * lineNumberOfReference);	//OLD
bool addLinesToByteArray(char * byteArray, char * lineByteArray, int * byteArraySize, int lineByteArraySize, int lineNumberToAdd);	//OLD
bool replaceLinesInByteArray(char * byteArray, char * lineByteArray, int * byteArraySize, int lineByteArraySize, int lineNumberToReplace, int numberOfLinesToReplace);	//OLD


#endif
