/*******************************************************************************
 *
 * File Name: LRRCsprite.h
 * Author: Richard Baxter
 * Project: Lego Rules CG Rounds Checker
 * Project Version: 3e2a 16-Feb-07
 * Project First Internal Release: 1aXx 18-Sept-05 (C)
 * Project Second Internal Release: 2aXx 02-April-06 (convert to C++)
 * Project Third Internal Release: 2b7d 26-Sept-06 (added sprites)
 * Project Fourth Internal Release: 2c4a 25-Feb-07 [rotation of models supported, copyCombatRelevantInheritedImmediateParentUnitDetailsIntoChildObject() no longer used]
 * Project Fifth Internal Release: 2d11a 3-June-07
 *
 *******************************************************************************/



/*spriteCode.cpp - 10-Sept-06 12:30pm - for integration into legoRulesRoundsChecker. This code allows the addition of a sprite into a given scene file where a sprite is a paragraph of text. [The text is to be rendered in 3D, and point towards the user POV - see CHECK THIS for missing code]*/

#ifndef HEADER_LRRC_SPRITE
#define HEADER_LRRC_SPRITE

#define CPLUSPLUSERRORCORRECTION1 (10000)
#define CPLUSPLUSERRORCORRECTION2 (500)
//#define CPLUSPLUSERRORCORRECTION3

#include "LDreferenceClass.h"

#define ANSI_DECIMAL_DIFF_BETWEEN_CASE_TEXT (32)

#define SPRITE_SUBMODEL_RANGE_FILE_NAME_NAME "SPRITE_SUBMODEL_RANGE_FILE_NAME"		//CHECKTHIS this can be changed between circle and ring depending upon High Resolution renderer; Ray Tracer versus LDVIEW [and taking into account other factors Eg LGEO parts library]
#define SPRITE_SUBMODEL_RANGE_MOVEMENT_COLOUR_TRANS_NAME "SPRITE_SUBMODEL_RANGE_MOVEMENT_COLOUR_TRANS"
#define SPRITE_SUBMODEL_RANGE_LONGDISTANCE_COMBAT_COLOUR_TRANS_NAME "SPRITE_SUBMODEL_RANGE_LONGDISTANCE_COMBAT_COLOUR_TRANS"
#define SPRITE_SUBMODEL_RANGE_CLOSE_COMBAT_COLOUR_TRANS_NAME "SPRITE_SUBMODEL_RANGE_CLOSE_COMBAT_COLOUR_TRANS"
#define SPRITE_SUBMODEL_RANGE_MOVEMENT_COLOUR_OPAQ_NAME "SPRITE_SUBMODEL_RANGE_MOVEMENT_COLOUR_OPAQ"
#define SPRITE_SUBMODEL_RANGE_LONGDISTANCE_COMBAT_COLOUR_OPAQ_NAME "SPRITE_SUBMODEL_RANGE_LONGDISTANCE_COMBAT_COLOUR_OPAQ"
#define SPRITE_SUBMODEL_RANGE_CLOSE_COMBAT_COLOUR_OPAQ_NAME "SPRITE_SUBMODEL_RANGE_CLOSE_COMBAT_COLOUR_OPAQ"
#define SPRITE_SUBMODEL_RANGE_SCALE_FACTOR_NAME "SPRITE_SUBMODEL_RANGE_SCALE_FACTOR"		//this value is now multiplied by LDRAW_UNITS_PER_CM 							//theoretically should be: LDRAW_UNITS_PER_CM	- old = 3.0 with ring
/*
#define SPRITE_SUBMODEL_RANGE_FILE_NAME "48\\4-4EDGE.DAT"		//CHECKTHIS this should be changed to a part that can be rendered in High Resolution in a Ray Tracer [Eg via LGEO parts library]
#define SPRITE_SUBMODEL_RANGE_MOVEMENT_COLOUR_TRANS (DAT_FILE_COLOUR_GREEN+DAT_FILE_COLOUR_TRANPARENT_MOD)
#define SPRITE_SUBMODEL_RANGE_LONGDISTANCE_COMBAT_COLOUR_TRANS (DAT_FILE_COLOUR_RED+DAT_FILE_COLOUR_TRANPARENT_MOD)	//OLD: (DAT_FILE_COLOUR_YELLOW+DAT_FILE_COLOUR_TRANPARENT_MOD)
#define SPRITE_SUBMODEL_RANGE_CLOSE_COMBAT_COLOUR_TRANS (DAT_FILE_COLOUR_RED+DAT_FILE_COLOUR_TRANPARENT_MOD)
#define SPRITE_SUBMODEL_RANGE_MOVEMENT_COLOUR_OPAQ (DAT_FILE_COLOUR_GREEN)
#define SPRITE_SUBMODEL_RANGE_LONGDISTANCE_COMBAT_COLOUR_OPAQ (DAT_FILE_COLOUR_RED) //OLD: (DAT_FILE_COLOUR_YELLOW)
#define SPRITE_SUBMODEL_RANGE_CLOSE_COMBAT_COLOUR_OPAQ (DAT_FILE_COLOUR_RED)
#define SPRITE_SUBMODEL_RANGE_SCALE_FACTOR (LDRAW_UNITS_PER_CM)		//theoretically should be: LDRAW_UNITS_PER_CM	- old = 3.0 with ring
*/

#define SPRITE_TEXTUAL_INCLUDE_DESCRIPTION_TEXT
#define SPRITE_TEXTUAL_NUM_OF_LINES (7) /*defence level, LD attack level, CC attack level, movement level*/
#define SPRITE_TEXTUAL_INCLUDE_NAME_INFO
#define SPRITE_TEXTUAL_INCLUDE_PLAYERID_INFO

#define SPRITE_DEFAULT_COLOUR_NAME "SPRITE_DEFAULT_COLOUR"
//#define SPRITE_DEFAULT_COLOUR (DAT_FILE_DEFAULT_COLOUR)

#define SPRITE_INDEX_MAGNITUDE (5)

//to determine SPRITE_LINE_SPACING_SIZE_IN_LDRAW_UNITS/SPRITE_CHAR_SPACING_SIZE_IN_LDRAW_UNITS
#define SPRITE_CHAR_PIXEL_TO_LDRAW_UNIT_RATIO_NAME "SPRITE_CHAR_PIXEL_TO_LDRAW_UNIT_RATIO"
#define SPRITE_TEXT_SCALE_FACTOR_NAME "SPRITE_TEXT_SCALE_FACTOR"	//this can easily be changed
#define SPRITE_TEXT_DICE_SCALE_FACTOR_NAME "SPRITE_TEXT_DICE_SCALE_FACTOR" //assume dice have already been appropriately scaled
#define SPRITE_CHAR_HEIGHT_IN_PIXELS_NAME "SPRITE_CHAR_HEIGHT_IN_PIXELS"
#define SPRITE_LINE_SPACING_RATIO_WITHOUT_DICE_PRESENT_NAME "SPRITE_LINE_SPACING_RATIO_WITHOUT_DICE_PRESENT"
/*
#define SPRITE_CHAR_PIXEL_TO_LDRAW_UNIT_RATIO (0.1)
#define SPRITE_TEXT_SCALE_FACTOR (2.0)	//this can easily be changed
#define SPRITE_TEXT_DICE_SCALE_FACTOR (1.0) //assume dice have already been appropriately scaled
#define SPRITE_CHAR_HEIGHT_IN_PIXELS (80)
#define SPRITE_LINE_SPACING_RATIO_WITHOUT_DICE_PRESENT (1.5)

#define SPRITE_HEIGHT_OF_CHARS_IN_LDRAW_UNITS (SPRITE_CHAR_HEIGHT_IN_PIXELS * SPRITE_CHAR_PIXEL_TO_LDRAW_UNIT_RATIO)
#define SPRITE_LINE_SPACING_RATIO (SPRITE_LINE_SPACING_RATIO_WITHOUT_DICE_PRESENT * SPRITE_TEXT_SCALE_FACTOR)	//OLD: SPRITE_LINE_SPACING_RATIO_WITHOUT_DICE_PRESENT/(SPRITE_TEXT_SCALE_FACTOR/4), //NB '/(SPRITE_TEXT_SCALE_FACTOR/4)' is due to dice size. without dice present SPRITE_LINE_SPACING_RATIO = (1.5)
#define SPRITE_LINE_SPACING_SIZE_IN_LDRAW_UNITS ((SPRITE_HEIGHT_OF_CHARS_IN_LDRAW_UNITS*SPRITE_LINE_SPACING_RATIO)*SPRITE_TEXT_SCALE_FACTOR)
*/




#define SPRITE_CHAR_WIDTH_IN_PIXELS_NAME "SPRITE_CHAR_WIDTH_IN_PIXELS" 	//original = 70
#define SPRITE_SMALL_CHAR_WIDTH_IN_PIXELS_NAME "SPRITE_SMALL_CHAR_WIDTH_IN_PIXELS"
#define SPRITE_DICE_WIDTH_IN_LDRAW_UNITS_NAME "SPRITE_DICE_WIDTH_IN_LDRAW_UNITS"
#define SPRITE_CHAR_SPACING_RATIO_NAME "SPRITE_CHAR_SPACING_RATIO"
/*
#define SPRITE_CHAR_WIDTH_IN_PIXELS (100)	//original = 70
#define SPRITE_SMALL_CHAR_WIDTH_IN_PIXELS (55)
#define SPRITE_DICE_WIDTH_IN_LDRAW_UNITS (100)
#define SPRITE_CHAR_SPACING_RATIO (0.7)

#define SPRITE_WIDTH_OF_CHARS_IN_LDRAW_UNITS (SPRITE_CHAR_WIDTH_IN_PIXELS * SPRITE_CHAR_PIXEL_TO_LDRAW_UNIT_RATIO)
#define SPRITE_WIDTH_OF_SMALL_CHARS_IN_LDRAW_UNITS (SPRITE_SMALL_CHAR_WIDTH_IN_PIXELS * SPRITE_CHAR_PIXEL_TO_LDRAW_UNIT_RATIO)
#define SPRITE_CHAR_SPACING_SIZE_IN_LDRAW_UNITS ((SPRITE_WIDTH_OF_CHARS_IN_LDRAW_UNITS * SPRITE_CHAR_SPACING_RATIO)*SPRITE_TEXT_SCALE_FACTOR)
#define SPRITE_SMALL_CHAR_SPACING_SIZE_IN_LDRAW_UNITS ((SPRITE_WIDTH_OF_SMALL_CHARS_IN_LDRAW_UNITS * SPRITE_CHAR_SPACING_RATIO)*SPRITE_TEXT_SCALE_FACTOR)
#define SPRITE_DICE_SPACING_SIZE_IN_LDRAW_UNITS ((SPRITE_DICE_WIDTH_IN_LDRAW_UNITS * SPRITE_CHAR_SPACING_RATIO)*SPRITE_TEXT_DICE_SCALE_FACTOR)
*/




#define SPRITES_FLOATING_WIDTH_IN_LDRAW_UNITS_NAME "SPRITES_FLOATING_WIDTH_IN_LDRAW_UNITS"
#define SPRITES_FLOATING_HEIGHT_IN_LDRAW_UNITS_NAME "SPRITES_FLOATING_HEIGHT_IN_LDRAW_UNITS"
/*
#define SPRITES_FLOATING_WIDTH_IN_LDRAW_UNITS (150)
#define SPRITES_FLOATING_HEIGHT_IN_LDRAW_UNITS (-250)
*/



/*
#define SPRITE_TEXT_DICE_ROTATION_DEGREES (90)
#define SPRITE_TEXT_DICE_ROTATION_AXIS 'x'
*/


#define SPRITE_TEXT_DICE_Y_OFFSET_NAME "SPRITE_TEXT_DICE_Y_OFFSET"
//#define SPRITE_TEXT_DICE_Y_OFFSET (+11.5)


#define SPRITES_DISPLAY_DICE
//#define SPRITE_ALWAYS_ADD_TEXT

#define SPRITE_HEADER_NAME "\n0 Start lrrc.exe Sprites\n"
#define SPRITE_TRAILER_NAME "0 End lrrc.exe Sprites\n"
#define SPRITE_HEADER_NUM_LINES (2)
#define SPRITE_TRAILER_NUM_LINES (1)
#define SPRITE_HEADER_LENGTH 26
#define SPRITE_TRAILER_LENGTH 23

#define SPRITE_NAME_START_NAME "SPRITE_NAME_START"
#define SPRITE_EXTENSION_NAME  "SPRITE_EXTENSION"
#define SPRITE_CHARACTER_START_NAME "SPRITE_CHARACTER_START"
#define SPRITE_CHARACTER_EXTENSION_NAME "SPRITE_CHARACTER_EXTENSION"		//sprite submodel extension
/*
#define SPRITE_NAME_START "sprite"
#define SPRITE_EXTENSION  ".ldr"
#define SPRITE_CHARACTER_START "spritetext"
#define SPRITE_CHARACTER_EXTENSION ".dat"		//sprite submodel extension
*/

#define SPRITE_CHARACTER_DICE_OFFSET (192)
#define SPRITE_CHARACTER_NUM_OFFSET (48)
#define MAX_ATTACK_DEFENCE_LEVEL (6)
#define MAX_DICE_ATTACK_DEFENCE_VALUE_SUPPORTED (5)			/*CHECK THIS: this will change once more spritetextdx.dat files are created - ie spritetextd12.dat [change to 6] and spritetextd20.dat [change to 10] are created*/
#define MIN_DICE_ATTACK_DEFENCE_VALUE_SUPPORTED (2)			/*CHECK THIS: this will change once more spritetextd2.dat file is created [change to 1]*/

void fillInSpriteExternVariables();

/*top level sprite routine*/
bool addUnitDetailsSpritesToSceneFile(char* sceneFileName, char* sceneFileNameWithSprites, bool addTextualSpriteInfo, bool addRangeSpriteInfo, int currentPhase, int currentPlayerTurn);
	void searchSceneRefListAddUnitDetailsSpriteForSubmodels(Reference * referenceInSceneFile, Reference * spriteListInitialReference, vec * eyeCoords, int * numSpritesAdded, char* sceneFileName, Reference * initialReferenceInSceneFile, bool addTextualSpriteInfo, bool addRangeSpriteInfo, int currentPhase, int currentPlayerTurn);
	//void searchSceneRefListAddUnitDetailsSpriteForSubmodels(Reference * referenceInSceneFile, char * spriteListByteArray, int * spriteListByteArraySize, vec * eyeCoords, int * numSpritesAdded, char* sceneFileName, Reference * initialReferenceInSceneFile);
		//bool determineSpriteInfoAndAddSpriteToSpriteRefList(Reference * topLevelReferenceInCurrentSubmodel, char * spriteListByteArray, int * spriteListByteArraySize, vec * eyeCoords, int * numSpritesAdded, char* sceneFileName);
		bool determineSpriteInfoAndAddSpriteToSpriteRefList(Reference * unitReference, Reference * targetReference, Reference * spriteListInitialReference, vec * eyeCoords, int * numSpritesAdded, char* sceneFileName, bool addTextualSpriteInfo, bool addRangeSpriteInfo, bool addTargetSpriteInfo, int currentPhase, int currentPlayerTurn);
			void generateTextualSpriteInfoString(Reference * unitReferenceInSceneFile, string * spriteTextString, int spriteColourArray[]);
			Reference * addTextualSpriteInfoStringToReferenceList(string * spriteTextString, int spriteColourArray[], Reference * spriteSubmodelInitialReference, int spriteNumberOfLines);
			Reference * addRangeSpriteInfoToReferenceList(Reference * spriteSubmodelInitialReference, ModelDetails * unitDetails, int currentPhase);
			Reference * addTargetSpriteInfoToReferenceList(Reference * spriteSubmodelInitialReference, Reference * unitReference, Reference * targetReference, int currentPhase);
			void createSpriteReferenceName(char * spriteReferenceFileName, int spriteIndex, char * sceneFileName);
			//bool addSpriteReferenceToSpriteListByteArray(vec * spriteSceneCoords, vec * eyeCoords, char * spriteListByteArray, int * spriteListByteArraySize, char * spriteReferenceFileName, int spriteDefaultColour);
			bool addSpriteToSpriteReferenceList(vec * spriteSceneCoords, vec * eyeCoords, Reference * spriteListInitialReference, char * spriteReferenceFileName, int spriteDefaultColour);
	bool addSpriteListByteArrayToSceneFile(char * sceneFileName, char * sceneFileNameWithSprites, char * spriteListByteArray, int spriteListByteArraySize, int spriteListByteArrayLines);

/*low level sprite routines*/
void spriteSubmodelFillTextualReference(Reference * spriteSubmodelCurrentReference, vec * spriteParagraphCurrentPosition, char characterToWrite, int spriteColour);
void generateSpriteRotationMatrix(vec * spriteSceneCoords, vec * eyeCoords, mat * spriteRotationMatrix);

#endif

