/*******************************************************************************
 *
 * File Name: XMLParserClass.h
 * Author: Richard Baxter
 * Project: Generic Construct Functions
 * Project Version: 3e2a 16-Feb-07
 *
 *******************************************************************************/



#ifndef XML_PARSER
#define XML_PARSER


#include <string>
#include <iostream>
#include <fstream>
#include <time.h>
#include <math.h>
using namespace std;

#endif


#define XML_FILE_MAX_SIZE (100000000)		//100MB


#ifndef XML_PARSER_ATTRIBUTE_CLASS
#define XML_PARSER_ATTRIBUTE_CLASS


class XMLParserAttribute
{
private:
	/*There are currently no private attributes of this class*/
public:

	XMLParserAttribute(void); // constructor
	~XMLParserAttribute();	// and destructor.

	string name;
	string value;

	XMLParserAttribute * nextAttribute;


};

#endif




#ifndef XML_PARSER_TAG_CLASS
#define XML_PARSER_TAG_CLASS

class XMLParserTag
{
private:
	/*There are currently no private attributes of this class*/
public:

	XMLParserTag(void); // constructor
	~XMLParserTag();	// and destructor.

	string name;
	string value;

	XMLParserTag * nextTag;
	XMLParserTag * firstLowerLevelTag;

	XMLParserAttribute * firstAttribute;
	XMLParserAttribute * currentAttribute;	//temporary variable used for attribute list creation

};

#endif



bool readXMLFile(string xmlFileName, XMLParserTag * firstTagInXMLFile);
bool parseTagOpen(ifstream * parseFileObject, XMLParserTag * currentTag, string parentTagName, bool isASubTag, int treeLayer);
	bool parseTagName(ifstream * parseFileObject, XMLParserTag * currentTag, string parentTagName, bool isASubTag, int treeLayer);
		bool parseTagAttributeName(ifstream * parseFileObject, XMLParserTag * currentTag, string parentTagName, bool isASubTag, int treeLayer);
			bool parseTagAttributeValue(ifstream * parseFileObject, XMLParserTag * currentTag, string parentTagName, bool isASubTag, int treeLayer);
		bool parseTagValueAssumingExistenceOfSubtabsAndClose(ifstream * parseFileObject, XMLParserTag * tag, XMLParserTag * subTag, string tagName, int treeLayer);
		bool parseTagComment(ifstream * parseFileObject);

//Low Level
bool isBlankChar(ifstream * parseFileObject, char c);
bool isBlankCharTabOrNewLine(ifstream * parseFileObject, char c);
void throwGenericXMLParseError();



bool writeXMLFile(string xmlFileName, XMLParserTag * firstTagInXMLFile);
	bool addTagLayerToByteArray(XMLParserTag * firstTagInCurrentLayer, char * XMLFileByteArray, long * XMLFileByteArrayCurrentPosition, int treeLayer);
		void incrementLineAndAddTabs(char * XMLFileByteArray, long * XMLFileByteArrayCurrentPosition, int treeLayer);
		void addTabs(char * XMLFileByteArray, long * XMLFileByteArrayCurrentPosition, int treeLayer);
		void writeStringToByteArray(string s, char * XMLFileByteArray, long * XMLFileByteArrayCurrentPosition);
	void writeFile(const char * fileName, char * fileByteArray, int fileByteArraySize);
